#ifndef __24X_H__
#define __24X_H__

#ifdef __cplusplus
extern "C" {
#endif

/* INTERRUPT */
#define rSRCPND         (*(volatile unsigned *)0x14400000)
#define rINTMOD         (*(volatile unsigned *)0x14400004)
#define rINTMSK         (*(volatile unsigned *)0x14400008)
#define rPRIORITY       (*(volatile unsigned *)0x1440000c)
#define rINTPND         (*(volatile unsigned *)0x14400010)
#define rINTOFFSET      (*(volatile unsigned *)0x14400014)

/* DMA */
#define rDISRC0         (*(volatile unsigned *)0x14600000)
#define rDIDST0         (*(volatile unsigned *)0x14600004)
#define rDCON0          (*(volatile unsigned *)0x14600008)
#define rDSTAT0         (*(volatile unsigned *)0x1460000c)
#define rDCSRC0         (*(volatile unsigned *)0x14600010)
#define rDCDST0         (*(volatile unsigned *)0x14600014)
#define rDMASKTRIG0     (*(volatile unsigned *)0x14600018)
#define rDISRC1         (*(volatile unsigned *)0x14600020)
#define rDIDST1         (*(volatile unsigned *)0x14600024)
#define rDCON1          (*(volatile unsigned *)0x14600028)
#define rDSTAT1         (*(volatile unsigned *)0x1460002c)
#define rDCSRC1         (*(volatile unsigned *)0x14600030)
#define rDCDST1         (*(volatile unsigned *)0x14600034)
#define rDMASKTRIG1     (*(volatile unsigned *)0x14600038)
#define rDISRC2         (*(volatile unsigned *)0x14600040)
#define rDIDST2         (*(volatile unsigned *)0x14600044)
#define rDCON2          (*(volatile unsigned *)0x14600048)
#define rDSTAT2         (*(volatile unsigned *)0x1460004c)
#define rDCSRC2         (*(volatile unsigned *)0x14600050)
#define rDCDST2         (*(volatile unsigned *)0x14600054)
#define rDMASKTRIG2     (*(volatile unsigned *)0x14600058)
#define rDISRC3         (*(volatile unsigned *)0x14600060)
#define rDIDST3         (*(volatile unsigned *)0x14600064)
#define rDCON3          (*(volatile unsigned *)0x14600068)
#define rDSTAT3         (*(volatile unsigned *)0x1460006c)
#define rDCSRC3         (*(volatile unsigned *)0x14600070)
#define rDCDST3         (*(volatile unsigned *)0x14600074)
#define rDMASKTRIG3     (*(volatile unsigned *)0x14600078)

/* CLOCK & POWER MANAGEMENT */
#define rLOCKTIME	(*(volatile unsigned *)0x14800000)
#define rMPLLCON	(*(volatile unsigned *)0x14800004)
#define rUPLLCON	(*(volatile unsigned *)0x14800008)
#define rCLKCON		(*(volatile unsigned *)0x1480000c)
#define rCLKSLOW	(*(volatile unsigned *)0x14800010)
#define rCLKDIVN	(*(volatile unsigned *)0x14800014)

/* USB DEVICE */
#define rFUNC_ADDR_REG  (*(volatile unsigned *)0x15200140)
#define rPWR_REG        (*(volatile unsigned *)0x15200144)
#define rINT_REG        (*(volatile unsigned *)0x15200148)
#define rINT_MASK_REG   (*(volatile unsigned *)0x1520014c)
#define rFRAME_NUM_REG  (*(volatile unsigned *)0x15200150)
#define rRESUME_CON_REG (*(volatile unsigned *)0x15200154)
#define rEP0_CSR        (*(volatile unsigned *)0x15200160)
#define rEP0_MAXP       (*(volatile unsigned *)0x15200164)
#define rEP0_OUT_CNT    (*(volatile unsigned *)0x15200168)
#define rEP0_FIFO       (*(volatile unsigned *)0x1520016c)
#define rEP1_IN_CSR     (*(volatile unsigned *)0x15200180)
#define rEP1_IN_MAXP    (*(volatile unsigned *)0x15200184)
#define rEP1_FIFO       (*(volatile unsigned *)0x15200188)
#define rEP2_IN_CSR     (*(volatile unsigned *)0x15200190)
#define rEP2_IN_MAXP    (*(volatile unsigned *)0x15200194)
#define rEP2_FIFO       (*(volatile unsigned *)0x15200198)
#define rEP3_OUT_CSR    (*(volatile unsigned *)0x152001a0)
#define rEP3_OUT_MAXP   (*(volatile unsigned *)0x152001a4)
#define rEP3_OUT_CNT    (*(volatile unsigned *)0x152001a8)
#define rEP3_FIFO       (*(volatile unsigned *)0x152001ac)
#define rEP4_OUT_CSR    (*(volatile unsigned *)0x152001b0)
#define rEP4_OUT_MAXP   (*(volatile unsigned *)0x152001b4)
#define rEP4_OUT_CNT    (*(volatile unsigned *)0x152001b8)
#define rEP4_FIFO       (*(volatile unsigned *)0x152001bc)
#define rDMA_CON        (*(volatile unsigned *)0x152001c0)
#define rDMA_UNIT       (*(volatile unsigned *)0x152001c4)
#define rDMA_FIFO       (*(volatile unsigned *)0x152001c8)
#define rDMA_TX         (*(volatile unsigned *)0x152001cc)
#define rTEST_MODE      (*(volatile unsigned *)0x152001f4)
#define rIN_CON_REG     (*(volatile unsigned *)0x152001f8)

/* I/O PORT */ 
#define rPACON		(*(volatile unsigned *)0x15600000)
#define rPADAT		(*(volatile unsigned *)0x15600004)
#define rPBCON		(*(volatile unsigned *)0x15600008)
#define rPBDAT		(*(volatile unsigned *)0x1560000c)
#define rPBUP		(*(volatile unsigned *)0x15600010)
#define rPCCON		(*(volatile unsigned *)0x15600014)
#define rPCDAT		(*(volatile unsigned *)0x15600018)
#define rPCUP		(*(volatile unsigned *)0x1560001c)
#define rPDCON		(*(volatile unsigned *)0x15600020)
#define rPDDAT		(*(volatile unsigned *)0x15600024)
#define rPDUP		(*(volatile unsigned *)0x15600028)
#define rPECON		(*(volatile unsigned *)0x1560002c)
#define rPEDAT		(*(volatile unsigned *)0x15600030)
#define rPEUP		(*(volatile unsigned *)0x15600034)
#define rPFCON		(*(volatile unsigned *)0x15600038)
#define rPFDAT		(*(volatile unsigned *)0x1560003c)
#define rPFUP		(*(volatile unsigned *)0x15600040)
#define rPGCON		(*(volatile unsigned *)0x15600044)
#define rPGDAT		(*(volatile unsigned *)0x15600048)
#define rPGUP		(*(volatile unsigned *)0x1560004c)
#define rOPENCR		(*(volatile unsigned *)0x15600050)
#define rMISCCR		(*(volatile unsigned *)0x15600054)
#define rEXTINT		(*(volatile unsigned *)0x15600058)

/* PENDING BIT */
#define BIT_EINT0       (1<<0)
#define BIT_EINT1       (1<<1)
#define BIT_EINT2       (1<<2)
#define BIT_EINT3       (1<<3)
#define BIT_EINT4       (1<<4)
#define BIT_EINT5       (1<<5)
#define BIT_EINT6       (1<<6)
#define BIT_EINT7       (1<<7)
#define BIT_TICK        (1<<8)
#define BIT_WDT         (1<<9)
#define BIT_TIMER0      (1<<10)
#define BIT_TIMER1      (1<<11)
#define BIT_TIMER2      (1<<12)
#define BIT_TIMER3      (1<<13)
#define BIT_TIMER4      (1<<14)
#define BIT_UERR01      (1<<15)
#define BIT_NOTUSED     (1<<16)
#define BIT_DMA0        (1<<17)
#define BIT_DMA1        (1<<18)
#define BIT_DMA2        (1<<19)
#define BIT_DMA3        (1<<20)
#define BIT_MMC         (1<<21)
#define BIT_SPI         (1<<22)
#define BIT_URXD0       (1<<23)
#define BIT_URXD1       (1<<24)
#define BIT_USBD        (1<<25)
#define BIT_USBH        (1<<26)
#define BIT_IIC         (1<<27)
#define BIT_UTXD0       (1<<28)
#define BIT_UTXD1       (1<<29)
#define BIT_RTC         (1<<30)
#define BIT_ADC         (1<<31)
#define BIT_ALLMSK      0xffffffff

#define ClearPending(bit) {\
                 rSRCPND = bit;\
                 rINTPND = bit;\
                 /*rINTPND;*/\
                 }       
//Wait until rINTPND is changed for the case that the ISR is very short.

#ifdef __cplusplus
}
#endif

#endif /*__24X_H___*/
