#define udword unsigned long
typedef struct _REQUEST_SENSE_DATA 
{
    unsigned char ResponseCode : 7;
    unsigned char Valid : 1;

    unsigned char SegmentNum;

    unsigned char SenseKey : 4;
    unsigned char Reserved0 : 1;
    unsigned char WrongLenIndicator : 1;
    unsigned char EndofMedium : 1;
    unsigned char FileMark : 1;

    unsigned char Info_0;
    unsigned char Info_1;
    unsigned char Info_2;
    unsigned char Info_3;

    unsigned char AdditionalSenseLen;

    unsigned char CommandSpecInfo_0;
    unsigned char CommandSpecInfo_1;
    unsigned char CommandSpecInfo_2;
    unsigned char CommandSpecInfo_3;

    unsigned char ASC;
    unsigned char ASCQ;
    unsigned char FieldReplacableUnitCode;
    unsigned char SenseKeySpec_0 : 7;
    unsigned char SenseKeySpecValid : 1;
    unsigned char SenseKeySpec_1;
    unsigned char SenseKeySpec_2;

} REQUEST_SENSE_DATA;

struct
{
	union
	{
		unsigned long dwsignature;
		char csignature[4];
	};
	long dwtag;
	long dwdataxferlen;
	unsigned char ucflags;
	unsigned char uclun;
	unsigned char uccblen;  // scsi control block length (max = 31)
	unsigned char uccb[16];
} usbc;

struct
{
	union
	{
		long dwsignature;
		char csignature[4];
	};
	long dwtag;
	long dwdataresidue;
	unsigned char status;
} usbs;

typedef struct _usbrequest
{
	unsigned char RequestType;
	unsigned char Request;
	union 
	{
		unsigned short Value;
		unsigned char ValueParts[2];
	};
	unsigned short Index;
	unsigned short Length;	
} usbrequest;

#define MASS_STORAGE_RESET 0xFF
#define MASS_STORAGE_GET_MAX_LUN 0xFE

/******************************************************************************************************************************************************/

void ReadBlock (void);
void USBInit (unsigned long numblocks, unsigned long blocksize);
void USBReset (void);
static void SendControlPacket (void);
void FullDebug (unsigned char v, unsigned char v1, unsigned char v2, unsigned char v3);
void SimpleDebug (unsigned char v);
static void QueueControlReply (unsigned char length);
static void ClearStall (char endpoint);
static void SetStall (char endpoint);
static char ProcessDeviceRequests (usbrequest * usbreq);
static char ProcessInterfaceRequests (usbrequest * usbreq);
static char ProcessEndpointRequests (usbrequest * usbreq);
static char ProcessStandardRequests (usbrequest * usbreq);
static char ProcessClassRequests (usbrequest * usbreq);
static void ProcessPkt (unsigned char *rx_buffer, unsigned char rx_len);
void USBComms(void);
void MassStorageInit (void);
void CreateSenseData (char Sense);
static char SendStatus (void);
static void RequestSense (void);
void SendBulkData (int size);
static char ProcessSCSICmd (void);
static void ReceiveWriteData (unsigned char write_len);
static char ValidCBW(void);
static void ReceiveUSBC (unsigned char rcv_len);
static void ep3_process (void);
void SendSectors (void);
static void ep1_process (void);
