#include "usb100.h"

USB_DEVICE_DESCRIPTOR usb_descriptor =
{
	18, // structure length
	USB_DEVICE_DESCRIPTOR_TYPE, // descriptor type (device descriptor)
	0x0100, // usb spec num
	0, // class code
	0, // sub class code
	0, // proto
	8, // ep0 max packet size
	0x03e6, // vendor id (gamepark)
	0x1234, // product id
	0x0100, // device release num
	0, // manuf string
	0, // product string
	0, // serial string
	1	// configurations
};

USB_CONFIGURATION_DESCRIPTOR usb_config = 
{
		sizeof (USB_CONFIGURATION_DESCRIPTOR), // length of struct
		USB_CONFIGURATION_DESCRIPTOR_TYPE,    // type
		sizeof(USB_CONFIGURATION_DESCRIPTOR)+
			sizeof(USB_INTERFACE_DESCRIPTOR)+
			(sizeof(USB_ENDPOINT_DESCRIPTOR)*2), // total size of hierarchy
		1, // num of interfaces
		1, // value to use to select this configuration
		0, // string index describing this config
		USB_CONFIG_SELF_POWERED, // attributes
		0 // power consumption
};

USB_INTERFACE_DESCRIPTOR usb_interface =
{
    sizeof (USB_INTERFACE_DESCRIPTOR),
    USB_INTERFACE_DESCRIPTOR_TYPE,
    0, // number of interface
    0, // alternate setting
    2, // number of endpoints
    USB_CLASS_CODE_MASSSTORAGE_CLASS_DEVICE,
    USB_SUBCLASS_CODE_SCSI,
    USB_PROTOCOL_CODE_BULK,
    0 // string to describe this interface
};

USB_ENDPOINT_DESCRIPTOR usb_ep1_tx =
{
	sizeof (USB_ENDPOINT_DESCRIPTOR),
	USB_ENDPOINT_DESCRIPTOR_TYPE,
	0x81, // end point 1, "in" endpoint (to host)
	USB_ENDPOINT_TYPE_BULK,
	64, // max packet size
	0 // polling interval, ignored for bulk
};

USB_ENDPOINT_DESCRIPTOR usb_ep1_rx =
{
	sizeof (USB_ENDPOINT_DESCRIPTOR),
	USB_ENDPOINT_DESCRIPTOR_TYPE,
	0x03, // end point 3, "out" endpoint (to us)
	USB_ENDPOINT_TYPE_BULK,
	64, // max packet size
	0 // polling interval, ignored for bulk
};

